function [f] = flt2(image)
//
// Perform folding filtration
// image - source array
//
// Created by D. Ushakov (dushakov@gmail.com)
//

h = [1   2   1;
     0   0   0;
    -1  -2  -1]
// Window
win = zeros(3, 3);
f = image;
mx = image;

printf('This may take a while...');
for i = 2:49
  for j = 2:49
    // Move current window
    win(1,1)=image(i-1,j-1)*h(1,1);
    win(1,2)=image(i-1,j)*h(1,2);
    win(1,3)=image(i-1,j+1)*h(1,3);
    win(2,1)=image(i,j-1)*h(2,1);
    win(2,2)=image(i,j)*h(2,2);
    win(2,3)=image(i,j+1)*h(2,3);
    win(3,1)=image(i+1,j-1)*h(3,1);
    win(3,2)=image(i+1,j)*h(3,2);
    win(3,3)=image(i+1,j+1)*h(3,3);

    mx(i,j) = abs(sum(win));
//    mx(i,j) = abs(image(i-1,j-1)+2*image(i-1,j)+image(i-1,j+1) - (image(i+1,j-1)+2*image(i+1,j)+image(i+1,j+1)));
  end;
end;

h=-h;
win = zeros(3, 3);
my = image;
my1 = image;
for i = 2:49
  for j = 2:49
    // Move current window
    win(1,1)=image(i-1,j-1)*h(1,1);
    win(1,2)=image(i-1,j)*h(1,2);
    win(1,3)=image(i-1,j+1)*h(1,3);
    win(2,1)=image(i,j-1)*h(2,1);
    win(2,2)=image(i,j)*h(2,2);
    win(2,3)=image(i,j+1)*h(2,3);
    win(3,1)=image(i+1,j-1)*h(3,1);
    win(3,2)=image(i+1,j)*h(3,2);
    win(3,3)=image(i+1,j+1)*h(3,3);
    
    my(i,j) = abs(win(1,1)+win(2,1)+win(3,1)+win(1,3)+win(2,3)+win(3,3));
//    my(i,j) = abs(image(i-1,j-1)*h(1,1)+h(1,2)*image(i,j-1)+h(1,3)*image(i+1,j-1) + (image(i-1,j+1)*h(3,1)+h(3,2)*image(i,j+1)+h(3,3)*image(i+1,j+1)) + image();
    my(i,j) = abs(image(i-1,j-1)+2*image(i,j-1)+image(i+1,j-1) - (image(i-1,j+1)+2*image(i,j+1)+image(i+1,j+1)));
    if my(i,j) ~= my1(i,j) then printf("%d - %d\n",my(i,j),my1(i,j));
    end;
  end;
end;

f=sqrt(mx.*mx + my.*my);

for i = 1:50
  for j = 1:50
    if abs(f(i,j))>255 then f(i,j) = 1
      else f(i,j) = 0;
    end;
  end;
end;

endfunction
